module(..., package.seeall)
local s = require'scheme'
----------------------------------------

local function restartDaemon(path, sch, conf, prevConf)
   local conf = s.addDefault(path, sch, conf, true)
   C.restartDaemon(path)

   if conf["adm-state"] == "up" then
      C.restartDaemon(path,
                      {"/bin/sh", "-c", conf.command},
                      {
                         noRestart = false,
                         atExit = C.increasingSleep,
                      }
                   )
   end
   return true
end


Daemons = s.newScheme {
   _H = "Daemons",
   _NAME = s.newScheme {
      _H = "DaemonsN",
      description = s.stringType{_H = "NetPingDaemonNDescription", _P = 100},
      ["adm-state"] = s.choiceType{
         _A = {"up", "down"},
         _H = "DaemonsNAdmstate",
         _D = "down",
         _P = 110,
      },
      _Z = restartDaemon,
      ["log"] =  s.newScheme{
         _H = "DaemonsNLog",
         _P = 50,
         _X = function(path)
                 path = s.clonePath(path, -1)
                 io.write(s.ser(path))
                 return C.getDaemonLog(path)
              end,
         _R = 'user',
      },
      ["command"] = s.stringType{
         _H = "DaemonsNCommand",
      },
   },
}