module(..., package.seeall)
local s = require'scheme'
----------------------------------------

function createScriptFile(conf, sch, filename, path)
   local function bashEval(s)
     return "eval '"..string.gsub(s or "", "'","'\"'\"'").."';"
   end
   local ret = false
   script = [[
         io.write("Netping started\n")
         local bashEval = function (s)
            return "eval '"..string.gsub(s or "", "'","'\"'\"'").."';"
         end
         local execute = function (...)
                      local pid
                      local res
                      local cause
                      posix=require"posix"
                      pid = posix.fork()
                      if(pid == 0) then
                         posix.exec(...)
                         --this will never run if no errors..
                         os.exit("255")
                      end
                      pid, cause, res = posix.wait(pid)
                      if(pid and cause == "exited") then
                         return res
                      else
                         return nil
                      end
                   end
         local states= ]] ..
      (conf.mode=="ping" and
       s.ser(
       {
               [1] = { ["init-script"] = "true",
               ["max-failures"] = 1,
               jumps = {other = "next",},
               ["test-script"] = [[
                     NET_PING_DESTINATION_IP=]]..conf.destination..[[;
                     NET_PING_SOURCE_IP=]]..(conf.source or "")..[[;
                     NSG_LAST_STATE='START';
                     sleep ]]..conf["start-delay"]..[[;
                     i=]]..conf.retry..[[;
                     while true;
                     do
                     c=]]..conf["packets"]..[[;
                     while [ $c -gt 0 ];
                     do
                  ]]..bashEval(conf["test-script"] or "ping -c 1 "..(conf.source and "-I "..conf.source.." " or "")..(conf.destination or ""))..[[
                        pingres=$?;
                        if [ $pingres -eq 0  ];
                        then
                           sleep ]]..conf.interval..[[;
                           break;
                        fi;
                        c=$(($c-1));
                      done;
                        if [ $pingres -eq 0 ];
                        then
                           if ! [ ''$NSG_LAST_STATE == ''UP ];
                           then
                              NET_PING_EVENT=RESTORE;
                        ]]..bashEval((conf["restore-script"] or "true"))..[[
                           fi;
                           NSG_LAST_STATE=UP;
                           i=]]..conf.retry..[[;
                        else
                            if [ $i -gt -1 ];
                            then
                               i=$(($i-1));
                            fi;
                        fi;
                        if [ $i == 0 ];
                        then
                           if ! [ ''$NSG_LAST_STATE == ''DOWN ];
                           then
                              NET_PING_EVENT=FAILURE;
                        ]]..bashEval(conf["failure-script"] or "true")..[[
                              NSG_LAST_STATE=DOWN;
                              sleep ]]..conf["start-delay"]..[[;
                           else
                              sleep ]]..conf.interval..[[;
                           fi;
                           i=]]..conf.retry..[[;
                        else
                           sleep ]]..conf.interval..[[;
                        fi;
                     done;
               ]],
            },
       }
       ,1)
       or
       s.ser(conf, 1))..
         [[

         local state = 1
         local newState
         local res
         while true do
            if not states[state] then state = 1 end
            io.write("Entering state:"..state.."\n")
            execute("/bin/sh","-c",bashEval(states[state]["init-script"] or ""))
            local count =  states[state]["max-failures"]
            while count > 0 do
               res =  execute("/bin/sh","-c", bashEval(states[state]["test-script"] or ""))
               if res ~= 0 then
                  count = count - 1
                  io.write("Test - FAIL("..tostring(res)..")! count:"..states[state]["max-failures"]-count.."\n")
               else
                  count =  states[state]["max-failures"]
                  io.write("Test - ok\n")
               end
               execute("/bin/sleep","1")
            end
            newState = states[state].jumps[res] or states[state].jumps.other or 0
            state = (newState == 0 or newState == "next") and  state + 1 or newState
         end
   ]]


 
   local f = io.open(filename, 'w')
   if f then
      f:write(script)
      f:close()
      ret = true
   end
   return ret
end

local function restartNetPingDaemon(path, sch, conf, prevConf)
   local conf = s.addDefault(path, sch, conf, true)
   local scriptFile = C.getOption(path,"scriptFile")
   if not scriptFile then
      scriptFile = os.tmpname()
      C.setOption(path, "scriptFile", scriptFile)
   end
   C.restartDaemon(path)

   if conf["adm-state"] == "up" then
      if createScriptFile(conf,sch, scriptFile, path) then
         C.restartDaemon(path,
                         {"/usr/bin/lua", scriptFile},
                         {
                            noRestart = false,
                            atExit = C.increasingSleep,
                         }
                      )
      end
   end
   return true
end

local jumpScheme = s.stringType{
         _V = function (val)
                 local hlp = "integer in range 1..255 or string:\"next\""
                 if type(val) == "number" then
                    if val==0 then
                       return "next"
                    else
                       return (s.integerVal(val, 0, 255)) or nil, hlp
                    end
                 elseif  type(val) == "string" then
                    return val == "next" and val
                 end
                 return nil, hlp
              end,
         _D = "next",
      }

local NetPingDaemonNM =  s.newScheme {
   _H = "NetPingDaemonNM",
   _P = 0,
   description = s.stringType{_H = "NetPingDaemonNMDescription", _P = 100},
   ["init-script"] = s.stringType{
      _P = 95,
      _H = "NetPingDaemonNMInitScript",
      _D = "sleep 5;"
   },
   ["test-script"] = s.stringType{
      _P = 90,
      _H = "NetPingDaemonNMTestScript",
      _D = "ping -c 1 0.0.0.0;",
   },
   ["max-failures"] =  s.integerType{
      _P = 85,
      _H = "NetPingDaemonNMMaxFailures",
      _A = {1, 255},
      _D = 3,
   },
   jumps = s.newScheme {
      _P = 80,
      _H = "NetPingDaemonNMJumps",
      other =  jumpScheme{
         _H = "NetPingDaemonNMJumpsOther",
      },
      _NAME_H = "NetPingDaemonNMJumpsNPrompt",
      _NAME_TYPE =  function(val)
                          return s.integerVal(val, 1, 255)
                       end,
      _NAME =  jumpScheme{
         _H = "NetPingDaemonNMJumpsN",
      },
   },
}

NetPingScheme = s.newScheme {
   _H = "NetPingDaemon",
   _NAME = s.newScheme {
      _N = function(sch, conf)
              local mode = (conf.mode ~= "expert") or nil
              return {
                 [1] =  nil,
                 _LIST = mode,
                 destination = not mode or nil,
                 source = not mode or nil,
                 interval = not mode or nil,
                 packets = not mode or nil,
                 retry = not mode or nil,
                 ["start-delay"] = not mode or nil,
                 ["failure-script"] = not mode or nil,
                 ["restore-script"] = not mode or nil,
                 ["test-script"] = not mode or nil,
              }
           end,
      _H = "NetPingDaemonN",
      mode = s.choiceType{
         _A = {"ping", "expert"},
         _H = "NetPingDaemonNMode",
         _D = "ping",
         _DEP = 1,
         _P = 100,
      },
      description = s.stringType{_H = "NetPingDaemonNDescription", _P = 100},
      ["adm-state"] = s.choiceType{
         _A = {"up", "down"},
         _H = "NetPingDaemonState",
         _D = "down",
         _P = 110,
      },
      _Z = restartNetPingDaemon,
      ["log"] =  s.newScheme{
         _H = "NetPingDaemonLog",
         _P = 50,
         _X = function(path)
                 path = s.clonePath(path, -1)
                 io.write(s.ser(path))
                 return C.getDaemonLog(path)
              end,
         _R = 'user',
      },
--start expert
      --we can`t hide this item through _N so function call needed
      [1] = function (_, path)
               local mode = C.getConfOrDefault(s.clonePath(path, -1, "mode"))
               return mode ~= 'ping' and NetPingDaemonNM or s.nilType{}
            end,
      _LIST = NetPingDaemonNM,
--end expert

--start ping
      destination = s.ipAddressType{
         _H = "NetPingNDestination",
         _D = "127.0.0.1",
      },
      source= s.ipAddressType{
         _H = "NetPingNSource",
      },
      interval = s.integerType{
         _H = "NetPingNInterval",
         _A = {1,64000},
         _D = 10,
      },
      packets = s.integerType{
         _H = "NetPingNPackets",
         _A = {1,100},
         _D = 3,
      },
      retry = s.integerType{
         _H = "NetPingNRetry",
         _A = {1,100},
         _D = 5,
      },
      ["start-delay"] = s.integerType{
         _H = "NetPingNStartdelay",
         _A = {1,3600},
         _D = 10,
      },
      ["failure-script"] = s.stringType{
         _H = "NetPingNFailurescript",
         _D = "",
      },
      ["restore-script"] = s.stringType{
         _H = "NetPingNRestorescript",
         _D = "",
      },
      ["test-script"] = s.stringType{
         _H = "NetPingNTestscript",
      },
--end ping
   },
}