module(..., package.seeall)
local s = require'scheme'

softwareScheme = s.newScheme{
  _H = "soft",
}

local function getParent(path, sesNum)
  local path = s.clonePath(path, -1)
  local sch = C.getSchemeByPath(path)
  local conf = C.getConfByPath(path) or {}
  local locConf = C.getConfByPath(path, sesNum) or {}
  for k, v in pairs(locConf) do
    conf[k] = v
  end
  conf = s.addDefault(path, sch, conf, true) --clone conf with defaults
  return sch, conf
end

--[[
local nsgupdateOptionsMap = {
  protocol = "--proto=",
  user = "--user=",
  password = "--passwd=",
  server = "--server=",
  port = "--port=",
  file = "--file=",
}
--]]

local function launchUpdate(path, sch, val, sesNum)
  local sch, conf = getParent(path, sesNum)
  local com = {"nsgupdate", "-i"}
  if  (path[#path]=="launch") then
     --FULL firmware update needed
     com[#com+1] = "-f"
  end
  if conf.url then
    com[#com+1] = conf.url
    --[[  else
    for par,val in pairs(conf) do
      local option = nsgupdateOptionsMap[par]
      if option then
        com[#com+1] = option..val
      end
  end
--]]
  end
  C.restartDaemon(path, com,
    {sesNum = sesNum, noTimestamp = true, noRestart = true}) 
end

softwareScheme["service-pack"] = s.newScheme{
  _H = "softServicePack",
  install = s.newScheme{
    _T = "string",
    _H = 'softServicePackInstall',
    _V = s.areyousureVal,
    _X = launchUpdate,
    _A = {"Service pack will be installed.\n"},
    _EX = { subtype = 'areyousure'},
    _XI = true,
    _P = 0,
  },
  url = s.stringType{
    _H = "softServicePackUrl",
    _P= 10,
  },
}

softwareScheme["full-update"] = s.newScheme{
  _H = "softUpdate",
  launch = s.newScheme{
    _T = "string",
    _H = 'softUpdateLaunch',
    _V = s.areyousureVal,
    _X = launchUpdate,
    _A = {"Full system update will be performed.\n"},
    _EX = { subtype = 'areyousure'},
    _XI = true,
    _P = 0,
  },
  url = s.stringType{
    _H = "softUpdateUrl",
    _P= 10,
  },
}
