module(..., package.seeall)
local s = require'scheme'

----------------------------------------
WiFiSecurityWep = s.newScheme {
   _H = "WifiCoSecurityWep",

   wep_default_key = s.newScheme{
      _H = "WifiCoSecurityWepWepDefaultKey",
      _T = "choice",
      _V = s.choiceVal,
      _A = { 
	 { 0, "Use key0"},
	 { 1, "Use key1"},
	 { 2, "Use key2"},
	 { 3, "Use key3"},
      },
   },
   key0 = s.newScheme{
      _H = "WifiCoSecurityWepKeysName",
      _T = 'string',
      _V = CheckWEPkey,
   },
   key1 = s.newScheme{
      _H = "WifiCoSecurityWepKeysName",
      _T = 'string',
      _V = CheckWEPkey,
   },
   key2 = s.newScheme{
      _H = "WifiCoSecurityWepKeysName",
      _T = 'string',
      _V = CheckWEPkey,
   },
   key3 = s.newScheme{
      _H = "WifiCoSecurityWepKeysName",
      _T = 'string',
      _V = CheckWEPkey,
   },
}

----------------------------------------
function CheckWEPkey (arg) 
   if arg then
      local wl = string.len(arg) -- WEP key length ()
      if wl == 5 or wl == 13 then
	 return arg
      end
      if wl == 10 or wl == 26 then
	 local a1 = string.match(arg, "%x*")
	 if a1 and (string.len(a1) == 10 or string.len(a1) == 26) then
	    return arg
	 end
      end
   end
   return nil, 'String (len: 5, 13) or hex value (len: 10, 26) '
end
----------------------------------------

function CheckPSKphrase(arg) 
   if arg and type(arg) == 'string' then
      if string.len(arg) >= 8 and  string.len(arg) <= 63 then
	 return arg
      end
   end 
   return nil, 'String (8..63) characters '
end
----------------------------------------
local function print_key(target, key_name, key_val)
   if key_val then
      local key_len = string.len(key_val)
      local quote = ""
      
      if key_len == 5 or key_len == 13 then 
	 quote = '\"'  -- qouted string
      end
      target[#target+1] = ("%s=%s%s%s"):format(key_name, quote, key_val, quote)
   end
end

function AddWepKeys(conf, target, param_name)
   if conf and target and 
      conf.wep_default_key and (conf.wep_default_key ~="none") then
   
      local wep_idx = tostring(conf.wep_default_key)
      target[#target+1] = param_name .. "=" .. wep_idx	
      
      print_key(target, "wep_key0", conf.key0)
      print_key(target, "wep_key1", conf.key1)
      print_key(target, "wep_key2", conf.key2)
      print_key(target, "wep_key3", conf.key3)
   end
end
-----------------------------------------------
WiFiDetailChannels = s.newScheme{
   _H = "WiFiDetailChannels",
   _T = "choice",
   _V = s.choiceVal,
   _A = { 
      { 1,  "2412 MHz"},
      { 2,  "2417 MHz"},
      { 3,  "2422 MHz"},
      { 4,  "2427 MHz"},
      { 5,  "2432 MHz"},
      { 6,  "2437 MHz"},
      { 7,  "2442 MHz"},
      { 8,  "2447 MHz"},
      { 9,  "2452 MHz"},
      { 10, "2457 MHz"},
      { 11, "2462 MHz"},
      { 12, "2467 MHz"},
      { 13, "2472 MHz"},
   },
   _D = 1,
}
